import javax.microedition.io.*;

public class Server implements Runnable
{	

	private int port;
	private ServerSocketConnection serverSocket;
	private Thread thread;
	
	public Server(int port)
	{
		this.port = port;
	}

	public Server()
	{
		this(333);
	}

	public void run()
	{
		try
		{
			// Open a server socket at the port specified (listen)
			serverSocket = (ServerSocketConnection) Connector.open("socket://:" + port);
                        
			while(true)
			{
				SocketConnection socket = (SocketConnection) serverSocket.acceptAndOpen();
                                new SocketThread(socket); //Open a new thread for each session -> handle multiple simultaneous sessions
			}		
		}
		catch(Exception e)
		{System.err.println("TELNET Server: " + e.getMessage());}
	}

	public void start()
	{
		// If thread is null, the server is not running
		
		if(thread == null)
		{
			// Change state and start a new thread
						
			thread = new Thread(this);
			thread.start();
		}
                
                System.out.println("TELNET Server: Server Started");
	}

	public void stop() throws Exception
	{
		thread = null;

		// Close the server socket to allow thread end
		
		if(serverSocket != null)
			serverSocket.close();
	}	
}