
import com.ewon.ewonitf.IOManager;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import javax.microedition.io.SocketConnection;

public class SocketThread implements Runnable{

    private SocketConnection socket;
    private Thread thread;

    SocketThread(SocketConnection socket) {
        this.socket = socket;
        if(thread == null)
	{	
             thread = new Thread(this);
             thread.start();
	}                
         
        System.out.println("TELNET Server: new session opened");
    }
    
    
    public void run() {
                    
            try {
                  InputStream input = socket.openInputStream();
                  OutputStream output = socket.openOutputStream();
                  String request = "";
                                
                  while(true)
                  {     
                      byte[] buffer = new byte[1024];
                      int length;                                 
                      if((length = input.read(buffer)) > 0 )
                      {
                         request += new String(buffer,0,length);                                                    
                         int CR_pos = request.indexOf('\r'); //DETECT END OF LINE
                                            
                         if (CR_pos> -1)                                            
                         {                
                             try
                             {  
                                 if (request.startsWith("exit")) //CLOSE SOCKET
                                     break;                                                    

                                 if (request.indexOf('=') > -1) //WRITE --> TAGNAME = NEWVALUE                          
                                 {
                                     float newValue = Float.parseFloat(Utils.Split(request, "=", 1));
                                     IOManager.writeTag(Utils.Split(request, "=", 0),newValue);
                                     output.write("OK\r\n".getBytes());
                                 }
                                 else //READ                                  
                                     output.write(String.valueOf(IOManager.readTag(request.substring(0, CR_pos)) + "\r\n").getBytes());
                             }                             
                             catch(Exception ex)                             
                             {
                                 output.write("Unknown Tag\r\n".getBytes());
                             }
                             
                             output.flush();                               
                             request = "";  
                           }
                        }
                     }
                  
                  //Close Socket/Session
                  input.close();                  
                  output.close();                  
                  socket.close();
                  System.out.println("TELNET Server: Session closed");
                  
            } 
            catch (IOException ex) 
            {            
                System.out.println("TELNET Server: " + ex.getMessage());
            }
    }
}
